
<!-- Improved compatibility of back to top link: See: https://github.com/othneildrew/Best-README-Template/pull/73 -->
<a name="readme-top"></a>
<!--
*** Thanks for checking out the Best-README-Template. If you have a suggestion
*** that would make this better, please fork the repo and create a pull request
*** or simply open an issue with the tag "enhancement".
*** Don't forget to give the project a star!
*** Thanks again! Now go create something AMAZING! :D
-->



<!-- PROJECT SHIELDS -->
<!--
*** I'm using markdown "reference style" links for readability.
*** Reference links are enclosed in brackets [ ] instead of parentheses ( ).
*** See the bottom of this document for the declaration of the reference variables
*** for contributors-url, forks-url, etc. This is an optional, concise syntax you may use.
*** https://www.markdownguide.org/basic-syntax/#reference-style-links
-->
[![Contributors][contributors-shield]][contributors-url]
[![Forks][forks-shield]][forks-url]
[![Stargazers][stars-shield]][stars-url]
[![Issues][issues-shield]][issues-url]
[![MIT License][license-shield]][license-url]


<!-- PROJECT LOGO -->
<br />
<div align="center">


<h3 align="center">express-ts-init</h3>

  <p align="center">
    A boilerplate for Express.js using TypeScript to reduce manual setup time. Follow clean architecture best practice.
    <br />
    <a href="https://github.com/mikah13/express-ts-init"><strong>Explore the docs »</strong></a>
    <br />
    <br />
    <a href="https://github.com/mikah13/express-ts-init">View Demo</a>
    ·
    <a href="https://github.com/mikah13/express-ts-init/issues">Report Bug</a>
    ·
    <a href="https://github.com/mikah13/express-ts-init/issues">Request Feature</a>
  </p>
</div>


<!-- TABLE OF CONTENTS -->
<details>
  <summary>Table of Contents</summary>
  <ol>
    <li>
      <a href="#about-the-project">About The Project</a>
      <ul>
        <li><a href="#built-with">Built With</a></li>
      </ul>
    </li>
    <li>
      <a href="#getting-started">Getting Started</a>
    </li>
 
  </ol>
</details>

<!-- ABOUT THE PROJECT -->
## About The Project

express-ts-init is a repository that serves as a foundational boilerplate for building web applications using the Express.js framework and TypeScript. This repository is made with the intention to follow the best practice for clean architecture as well as type safety.

<p align="right">(<a href="#readme-top">back to top</a>)</p>




### Built With

* [![Express][Express.js]][express-url]
* [![TypeScript][TypeScript]][TypeScript-url]


<p align="right">(<a href="#readme-top">back to top</a>)</p>


### Installation

_Below is an example of how you can instruct your audience on installing and setting up your app. This template doesn't rely on any external dependencies or services._

1. Clone the repo
   ```sh
   git clone https://github.com/mikah13/express-ts-init.git
   ```
2. Install NPM packages
   ```sh
   pnpm install
   ```
3. Enter your environments variables in .env files 
   ```
    # App's running environment
    NODE_ENV=

    # App's running port
    PORT=3000

    # Cors origin url
    CORS_ORIGIN=
   ```

4. Run the project in development mode
    ```sh
    pnpm run dev
    ```

<p align="right">(<a href="#readme-top">back to top</a>)</p>